From ae459d60e0e841ee02028761e2e265097d9e7f30 Mon Sep 17 00:00:00 2001
From: "Schlegel, Dr. Fabian (FWDC) - 107795" <f.schlegel@hzdr.de>
Date: Mon, 6 Apr 2020 18:33:59 +0200
Subject: [PATCH] Adding multiphase solver cipsaMultiphaseEulerFoam

    Solver, which makes use of the compact momentum interpolation method,
    according to:

    Cubero, A. and Fueyo, N. (2007).
    A compact momentum interpolation procedure for unsteady flows and
    relaxation.
    Numerical Heat Transfer, Part B: Fundamentals, 52(6):507-529.

    * A partial elimination sum formulation is added to
      approximately resolve phase coupling due to the large drag coefficient for
      an arbitrary number of phases
    * The virtual mass force is handled consistently
    * Necessary infrastructure in phaseSystems is added
    * New drag models are added: StrubeljTiselj, IshiiZuberSparse
    * A new blending method is added: definitePhases
---
 .../multiphase/reactingEulerFoam/Allwclean    |   1 +
 .../multiphase/reactingEulerFoam/Allwmake     |   1 +
 .../cipsaMultiphaseEulerFoam/CourantNo.H      |  60 +++++
 .../cipsaMultiphaseEulerFoam/Make/files       |   3 +
 .../cipsaMultiphaseEulerFoam/Make/options     |  25 ++
 .../cipsaMultiphaseEulerFoam.C                | 125 ++++++++++
 .../createFieldRefs.H                         |  46 ++++
 .../cipsaMultiphaseEulerFoam/createFields.H   |  79 +++++++
 .../initZeroPtrList.H                         |  82 +++++++
 .../cipsaMultiphaseEulerFoam/pU/HUEqn.H       |  79 +++++++
 .../cipsaMultiphaseEulerFoam/pU/UEqns.H       | 205 ++++++++++++++++
 .../cipsaMultiphaseEulerFoam/pU/ddtUEqn.H     |  47 ++++
 .../cipsaMultiphaseEulerFoam/pU/dragDiag.H    |  65 ++++++
 .../cipsaMultiphaseEulerFoam/pU/dragSource.H  |  68 ++++++
 .../cipsaMultiphaseEulerFoam/pU/dragSourcef.H |  61 +++++
 .../pU/forcesSource.H                         |  36 +++
 .../pU/forcesSourcef.H                        |  36 +++
 .../cipsaMultiphaseEulerFoam/pU/pEqn.H        | 218 ++++++++++++++++++
 .../pU/stabilizeHUEqn.H                       |  43 ++++
 .../cipsaMultiphaseEulerFoam/pU/vmDiag.H      |  16 ++
 .../cipsaMultiphaseEulerFoam/pU/vmSource.H    |  22 ++
 .../cipsaMultiphaseEulerFoam/pU/vmSourcef.H   |  23 ++
 .../interfacialModels/Make/files              |   2 +
 .../IshiiZuberSparse/IshiiZuberSparse.C       |  83 +++++++
 .../IshiiZuberSparse/IshiiZuberSparse.H       | 105 +++++++++
 .../StrubeljTiselj/StrubeljTiselj.C           |  94 ++++++++
 .../StrubeljTiselj/StrubeljTiselj.H           | 121 ++++++++++
 .../BlendedInterfacialModel.C                 |   4 +-
 .../definitePhases/definitePhases.C           | 140 +++++++++++
 .../definitePhases/definitePhases.H           | 152 ++++++++++++
 .../reactingEulerFoam/phaseSystems/Make/files |   1 +
 .../MomentumTransferPhaseSystem.C             | 203 +++++++++++++++-
 .../MomentumTransferPhaseSystem.H             | 139 ++++++++++-
 .../MovingPhaseModel/MovingPhaseModel.C       |  12 +-
 .../MovingPhaseModel/MovingPhaseModel.H       |   7 +-
 .../StationaryPhaseModel.C                    |  19 +-
 .../StationaryPhaseModel.H                    |   7 +-
 .../phaseModel/phaseModel/phaseModel.C        |  15 +-
 .../phaseModel/phaseModel/phaseModel.H        |  20 +-
 .../phasePair/phasePair/phasePair.C           |  23 +-
 .../phaseSystems/phaseSystem/phaseSystem.C    |  89 ++++++-
 .../phaseSystems/phaseSystem/phaseSystem.H    |  30 ++-
 .../phaseSystems/phaseSystem/phaseSystemI.H   |  11 +-
 .../multiphaseSystem/multiphaseSystem.H       | 132 ++++++++++-
 44 files changed, 2727 insertions(+), 23 deletions(-)
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/CourantNo.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/files
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/options
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/cipsaMultiphaseEulerFoam.C
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFieldRefs.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFields.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/initZeroPtrList.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/HUEqn.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/UEqns.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/ddtUEqn.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragDiag.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSource.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSourcef.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSource.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSourcef.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/pEqn.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/stabilizeHUEqn.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmDiag.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSource.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSourcef.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.C
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.C
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/StrubeljTiselj/StrubeljTiselj.H
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.C
 create mode 100644 applications/solvers/multiphase/reactingEulerFoam/phaseSystems/BlendedInterfacialModel/blendingMethods/definitePhases/definitePhases.H

diff --git a/applications/solvers/multiphase/reactingEulerFoam/Allwclean b/applications/solvers/multiphase/reactingEulerFoam/Allwclean
index 40a8acade..a5f64a484 100755
--- a/applications/solvers/multiphase/reactingEulerFoam/Allwclean
+++ b/applications/solvers/multiphase/reactingEulerFoam/Allwclean
@@ -7,6 +7,7 @@ wclean libso interfacialCompositionModels
 wclean libso derivedFvPatchFields
 reactingTwoPhaseEulerFoam/Allwclean
 reactingMultiphaseEulerFoam/Allwclean
+wclean libso cipsaMultiphaseEulerFoam
 wclean libso functionObjects
 
 #------------------------------------------------------------------------------
diff --git a/applications/solvers/multiphase/reactingEulerFoam/Allwmake b/applications/solvers/multiphase/reactingEulerFoam/Allwmake
index 77f61dd78..2d77123ee 100755
--- a/applications/solvers/multiphase/reactingEulerFoam/Allwmake
+++ b/applications/solvers/multiphase/reactingEulerFoam/Allwmake
@@ -10,6 +10,7 @@ wmake $targetType interfacialCompositionModels
 wmake $targetType derivedFvPatchFields
 reactingTwoPhaseEulerFoam/Allwmake $targetType $*
 reactingMultiphaseEulerFoam/Allwmake $targetType $*
+wmake $targetType cipsaMultiphaseEulerFoam
 wmake $targetType functionObjects
 
 #------------------------------------------------------------------------------
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/CourantNo.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/CourantNo.H
new file mode 100644
index 000000000..d1d28ab5c
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/CourantNo.H
@@ -0,0 +1,60 @@
+/*---------------------------------------------------------------------------*\
+  =========                 |
+  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
+   \\    /   O peration     | Website:  https://openfoam.org
+    \\  /    A nd           | Copyright (C) 2011-2020 OpenFOAM Foundation
+     \\/     M anipulation  |
+-------------------------------------------------------------------------------
+License
+    This file is part of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+Global
+    CourantNo
+
+Description
+    Calculates and outputs the mean and maximum Courant Numbers.
+
+\*---------------------------------------------------------------------------*/
+
+scalar CoNum = 0.0;
+scalar meanCoNum = 0.0;
+
+if (mesh.nInternalFaces())
+{
+    scalarField sumPhi
+    (
+        fvc::surfaceSum(mag(phi))().primitiveField()
+    );
+
+    forAll(phases, phasei)
+    {
+        sumPhi = max
+        (
+            sumPhi,
+            fvc::surfaceSum(mag(phases[phasei].phi()))().primitiveField()
+        );
+    }
+
+    CoNum = 0.5*gMax(sumPhi/mesh.V().field())*runTime.deltaTValue();
+
+    meanCoNum =
+        0.5*(gSum(sumPhi)/gSum(mesh.V().field()))*runTime.deltaTValue();
+}
+
+Info<< "Courant Number mean: " << meanCoNum
+    << " max: " << CoNum << endl;
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/files b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/files
new file mode 100644
index 000000000..3299c2137
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/files
@@ -0,0 +1,3 @@
+cipsaMultiphaseEulerFoam.C
+
+EXE = $(FOAM_APPBIN)/cipsaMultiphaseEulerFoam
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/options b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/options
new file mode 100644
index 000000000..f8cc5e8d8
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/Make/options
@@ -0,0 +1,25 @@
+EXE_INC = \
+    -I../reactingMultiphaseEulerFoam/multiphaseSystem/lnInclude \
+    -I../phaseSystems/lnInclude \
+    -I../interfacialModels/lnInclude \
+    -I../interfacialCompositionModels/lnInclude \
+    -I../reactingMultiphaseEulerFoam/multiphaseCompressibleTurbulenceModels/lnInclude \
+    -I$(LIB_SRC)/thermophysicalModels/basic/lnInclude \
+    -I$(LIB_SRC)/transportModels/compressible/lnInclude \
+    -I$(LIB_SRC)/TurbulenceModels/turbulenceModels/lnInclude \
+    -I$(LIB_SRC)/TurbulenceModels/compressible/lnInclude \
+    -I$(LIB_SRC)/TurbulenceModels/phaseCompressible/lnInclude \
+    -I$(LIB_SRC)/finiteVolume/lnInclude \
+    -I$(LIB_SRC)/meshTools/lnInclude \
+    -I$(LIB_SRC)/sampling/lnInclude
+
+EXE_LIBS = \
+    -lreactingPhaseSystem \
+    -lreactingMultiphaseSystem \
+    -lreactingEulerianInterfacialModels \
+    -lreactingEulerianInterfacialCompositionModels \
+    -lmultiphaseReactingTurbulenceModels \
+    -lfiniteVolume \
+    -lfvOptions \
+    -lmeshTools \
+    -lsampling
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/cipsaMultiphaseEulerFoam.C b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/cipsaMultiphaseEulerFoam.C
new file mode 100644
index 000000000..fc465e032
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/cipsaMultiphaseEulerFoam.C
@@ -0,0 +1,125 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+Application
+    cipsaMultiphaseEulerFoam
+
+Description
+    Solver for a system of any number of incompressible fluid phases with a
+    common pressure, but otherwise separate properties. The solver uses the
+    consistent momentum interpolation method of Cubero et al. (2014) and a
+    partial-elimination algorithm.
+
+    Reference:
+    \verbatim
+        Cubero, A., Sánchez-Insa, A., & Fueyo, N. (2014).
+        A consistent momentum interpolation method for steady and unsteady
+        multiphase flows.
+        Computers & Chemical Engineering, 62, 96-107.
+    \endverbatim
+
+\*---------------------------------------------------------------------------*/
+
+#include "fvCFD.H"
+#include "multiphaseSystem.H"
+#include "phaseCompressibleTurbulenceModel.H"
+#include "pimpleControl.H"
+#include "initZeroPtrList.H"
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+int main(int argc, char *argv[])
+{
+    #include "postProcess.H"
+
+    #include "setRootCase.H"
+    #include "createTime.H"
+    #include "createMesh.H"
+    #include "createControl.H"
+    #include "createTimeControls.H"
+    #include "createFields.H"
+    #include "createFieldRefs.H"
+    #include "CourantNo.H"
+    #include "setInitialDeltaT.H"
+
+    Switch faceMomentum
+    (
+        pimple.dict().lookupOrDefault<Switch>("faceMomentum", false)
+    );
+
+    Switch partialElimination
+    (
+        pimple.dict().lookupOrDefault<Switch>("partialElimination", true)
+    );
+
+    // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+    Info<< "\nStarting time loop\n" << endl;
+
+    while (pimple.run(runTime))
+    {
+        #include "readTimeControls.H"
+        #include "CourantNo.H"
+        #include "setDeltaT.H"
+
+        runTime++;
+
+        Info<< "Time = " << runTime.timeName() << nl << endl;
+
+        // --- Pressure-velocity corrector loop (PIMPLE)
+        while (pimple.loop())
+        {
+            fluid.solve(rAUs, rHAUfs);
+            fluid.correct();
+
+            #include "pU/UEqns.H"
+
+            // --- Pressure corrector loop (PISO)
+            while (pimple.correct())
+            {
+                #include "pU/pEqn.H"
+            }
+
+            // Update material derivitives
+            fluid.correctKinematics();
+
+            if (pimple.turbCorr())
+            {
+                fluid.correctTurbulence();
+            }
+        }
+
+        runTime.write();
+
+        Info<< "ExecutionTime = " << runTime.elapsedCpuTime() << " s"
+            << "  ClockTime = " << runTime.elapsedClockTime() << " s"
+            << nl << endl;
+    }
+
+    Info<< "End\n" << endl;
+
+    return 0;
+}
+
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFieldRefs.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFieldRefs.H
new file mode 100644
index 000000000..249867420
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFieldRefs.H
@@ -0,0 +1,46 @@
+surfaceScalarField& phi = fluid.phi();
+
+List<scalar> relaxU(phases.size());
+PtrList<surfaceScalarField> alphafs(phases.size());
+
+// Equations
+PtrList<fvVectorMatrix> HUEqns(phases.size());
+PtrList<fvVectorMatrix> ddtUEqns(phases.size());
+PtrList<surfaceScalarField> ddtPhiCoeffs(phases.size());
+
+// Cell-based coefficients
+PtrList<volScalarField> rHUs(phases.size());
+PtrList<volScalarField> rAs(phases.size());
+PtrList<volScalarField> rAUs; // Dummy argument for solveAlphas()
+
+PtrList<volScalarField> dragDiag(phases.size());
+PtrList<volVectorField> dragSource(phases.size());
+
+PtrList<volScalarField> vmDiag(phases.size());
+PtrList<volVectorField> vmSource(phases.size());
+
+PtrList<volVectorField> forcesSource(phases.size());
+
+// Face-based coefficients
+PtrList<surfaceScalarField> rHUfs(phases.size());
+PtrList<surfaceScalarField> rAfs(phases.size());
+PtrList<surfaceScalarField> rAUfs(phases.size());
+PtrList<surfaceScalarField> rHAUfs(phases.size()); // Argument for solveAlphas()
+PtrList<surfaceScalarField> alpharAUfs(phases.size());
+
+PtrList<surfaceScalarField> dragDiagf(phases.size());
+PtrList<surfaceScalarField> dragSourcef(phases.size());
+PtrList<surfaceScalarField> dragPCoefff(phases.size());
+
+PtrList<surfaceScalarField> vmDiagf(phases.size());
+PtrList<surfaceScalarField> vmSourcef(phases.size());
+
+PtrList<surfaceScalarField> forcesSourcef(phases.size());
+
+// Cell velocities
+PtrList<volVectorField> HbyAs(phases.size());
+
+// Face fluxes
+PtrList<surfaceScalarField> HbyASumf(phases.size());
+PtrList<surfaceScalarField> phigs(phases.size());
+PtrList<surfaceScalarField> phiHbyAs(phases.size());
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFields.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFields.H
new file mode 100644
index 000000000..3f659cd22
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/createFields.H
@@ -0,0 +1,79 @@
+#include "readGravitationalAcceleration.H"
+#include "readhRef.H"
+
+Info<< "\nCreating phaseSystem\n" << endl;
+
+autoPtr<multiphaseSystem> fluidPtr
+(
+    multiphaseSystem::New(mesh)
+);
+multiphaseSystem& fluid = fluidPtr();
+multiphaseSystem::phaseModelList& phases = fluid.phases();
+
+// Create mixture density and velocity
+volScalarField rho("rho", fluid.rho());
+volVectorField U("U", fluid.U());
+
+dimensionedScalar pMin
+(
+    "pMin",
+    dimPressure,
+    fluid
+);
+
+#include "gh.H"
+
+volScalarField& p = phases[0].thermoRef().p();
+
+Info<< "Reading field p_rgh\n" << endl;
+volScalarField p_rgh
+(
+    IOobject
+    (
+        "p_rgh",
+        runTime.timeName(),
+        mesh,
+        IOobject::MUST_READ,
+        IOobject::AUTO_WRITE
+    ),
+    mesh
+);
+
+label pRefCell = 0;
+scalar pRefValue = 0.0;
+if (fluid.incompressible())
+{
+    p = max(p_rgh + fluid.rho()*gh, pMin);
+
+    if (p_rgh.needReference())
+    {
+        setRefCell
+        (
+            p,
+            p_rgh,
+            pimple.dict(),
+            pRefCell,
+            pRefValue
+        );
+
+        p += dimensionedScalar
+        (
+            "p",
+            p.dimensions(),
+            pRefValue - getRefCellValue(p, pRefCell)
+        );
+        p_rgh = p - fluid.rho()*gh;
+    }
+}
+
+mesh.setFluxRequired(p_rgh.name());
+
+// Do some checks and abort if necessary
+if (Switch(pimple.dict().lookup("correctFixedFluxBCs")[0].wordToken()))
+{
+    FatalErrorInFunction
+        << "Option correctFixedFluxBCs "
+        << "- required for BlendedInterfacialModel - "
+        << "has to be turned off for this solver."
+        << exit(FatalError);
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/initZeroPtrList.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/initZeroPtrList.H
new file mode 100644
index 000000000..c7816d470
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/initZeroPtrList.H
@@ -0,0 +1,82 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+InNamespace
+    Foam
+
+Description
+    Initialize the fields of a PtrList with zero
+
+\*---------------------------------------------------------------------------*/
+
+#ifndef initZeroPtrList_H
+#define initZeroPtrList_H
+
+#include "volFieldsFwd.H"
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+namespace Foam
+{
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+template<class Type,  template< class > class PatchField, class GeoMesh>
+void initZeroPtrList
+(
+    PtrList<GeometricField<Type, PatchField, GeoMesh>>& a,
+    const fvMesh& mesh,
+    const dimensionSet& ds,
+    const word& name
+)
+{
+    using T = Foam::GeometricField<Type, PatchField, GeoMesh>;
+
+    forAll(a, i)
+    {
+        if (a.set(i))
+        {
+            a[i] == Zero;
+        }
+        else
+        {
+            a.set
+            (
+                i,
+                T::New(name, mesh, dimensioned<Type>(ds, Zero))
+            );
+        }
+    }
+
+    return;
+}
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+} // End namespace Foam
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+#endif
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/HUEqn.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/HUEqn.H
new file mode 100644
index 000000000..07419a8b5
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/HUEqn.H
@@ -0,0 +1,79 @@
+forAll(phases, phasei)
+{
+    phaseModel& phase = phases[phasei];
+    volVectorField& UAlpha = phase.URef();
+
+    HUEqns.set
+    (
+        phasei,
+        (
+            fvm::div(phase.alphaRhoPhi(), UAlpha)
+          + phase.divDevRhoReff(UAlpha)
+          + fvm::SuSp(- fvc::div(phase.alphaRhoPhi()), UAlpha)
+        )
+    );
+}
+
+// Create U & grad(U) fields
+PtrList<fvVectorMatrix> UgradUs(phases.size());
+forAll(phases, phasei)
+{
+    const phaseModel& phase = phases[phasei];
+    const volVectorField& UAlpha = phase.U();
+    const surfaceScalarField& phiAlpha = phase.phi();
+
+    UgradUs.set
+    (
+        phasei,
+        new fvVectorMatrix
+        (
+            fvm::div(phiAlpha, UAlpha)
+          + fvm::SuSp(- fvc::div(phiAlpha), UAlpha)
+        )
+    );
+}
+
+// Add convective part of the virtual mass force
+forAllConstIter(multiphaseSystem::VmTable, fluid.Vms(), VmIter)
+{
+    const volScalarField& Vm(*VmIter());
+    const phasePair& pair(fluid.phasePairs()[VmIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        HUEqns[phase.index()] +=
+            Vm
+           *(
+                UgradUs[phase.index()]
+              - (UgradUs[otherPhase.index()] & otherPhase.U())
+            );
+    }
+}
+
+// Relaxation factor
+forAll(phases, phasei)
+{
+    word name = HUEqns[phasei].psi().select(pimple.finalPimpleIter());
+
+    relaxU[phasei] = 1;
+
+    if (HUEqns[phasei].psi().mesh().relaxField(name))
+    {
+        relaxU[phasei] =
+            HUEqns[phasei].psi().mesh().fieldRelaxationFactor(name);
+
+        if
+        (
+            pimple.finalPimpleIter()
+         && HUEqns[phasei].psi().mesh().fieldRelaxationFactor(name) != 1
+        )
+        {
+            Warning << "Field relaxation factor of " << relaxU[phasei]
+                    << " for solution variable '" << name
+                    << "' is not recommended." << endl << endl;
+        }
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/UEqns.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/UEqns.H
new file mode 100644
index 000000000..9583f9915
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/UEqns.H
@@ -0,0 +1,205 @@
+// Update mixture properties
+rho = fluid.rho();
+U = fluid.U();
+
+// Store velocity and flux of previous iteration
+forAll(phases, phasei)
+{
+    phases[phasei].URef().storePrevIter();
+    phases[phasei].phiRef().storePrevIter();
+}
+
+// Mixture density gradient times gravitational acceleration
+const surfaceScalarField ghSnGradRho
+(
+    "ghSnGradRho",
+    ghf*fvc::snGrad(rho)*mesh.magSf()
+);
+
+// Update drag and virtual mass coefficient table and interfacial forces tables
+fluid.momentumTransfer();
+
+// Time derivative equation
+#include "pU/ddtUEqn.H"
+
+// Convection, diffusion equation
+#include "pU/HUEqn.H"
+#include "pU/stabilizeHUEqn.H"
+
+// alphafs, rHUs, rHUfs, rAs, rAfs
+forAll(phases, phasei)
+{
+    phaseModel& phase = phases[phasei];
+    const volScalarField& alpha = phase;
+
+    // Face volume fractions
+    alphafs.set(phasei, fvc::interpolate(alpha));
+
+    rHUs.set(phasei, 1.0/HUEqns[phasei].A());
+    rHUfs.set(phasei, fvc::interpolate(rHUs[phasei]));
+
+    // Diagonal coefficients
+    rAs.set
+    (
+        phasei,
+        1.0/(HUEqns[phasei].A() + ddtUEqns[phasei].A())
+    );
+    rAfs.set
+    (
+        phasei,
+        1.0
+       /(
+            fvc::interpolate(HUEqns[phasei].A())
+          + fvc::interpolate(ddtUEqns[phasei].A())
+        )
+    );
+}
+
+// Implicit and pressure part of the drag
+#include "pU/dragDiag.H"
+
+// Implicit part of the time derivative of the virtual mass
+#include "pU/vmDiag.H"
+
+// Momentum predictor
+if (pimple.momentumPredictor())
+{
+    // Explicit part of the drag terms
+    #include "pU/dragSource.H"
+
+    // Explicit part of the time derivative of the virtual mass
+    #include "pU/vmSource.H"
+
+    // Add lift, wall lubrication and turbulent dispersion forces
+    #include "pU/forcesSource.H"
+
+    // rAUfs, alpharAUfs, phigs WITHOUT field relaxation of UAlpha
+    forAll(phases, phasei)
+    {
+        phaseModel& phase = phases[phasei];
+
+        rAUfs.set
+        (
+            phasei,
+            1.0
+           /(
+                1.0
+              + rHUfs[phasei]*fvc::interpolate(ddtUEqns[phasei].A())
+              + rHUfs[phasei]*dragDiagf[phasei]
+              + rHUfs[phasei]*vmDiagf[phasei]
+            )
+        );
+
+        // Phase diagonal coefficients
+        alpharAUfs.set
+        (
+            phasei,
+            rHUfs[phasei]*rAUfs[phasei]
+           *(alphafs[phasei] + dragPCoefff[phasei])
+        );
+
+        // Combined buoyancy and force fluxes
+        phigs.set
+        (
+            phasei,
+            alpharAUfs[phasei]
+           *(
+              - ghSnGradRho
+              + fluid.surfaceTension(phase)*mesh.magSf()
+            )
+        );
+    }
+
+    // Momentum predictor equation
+    forAll(phases, phasei)
+    {
+        phaseModel& phase = phases[phasei];
+        const volScalarField& alpha = phase;
+        volVectorField& UAlpha = phase.URef();
+
+        fvVectorMatrix UEqns
+        (
+            ddtUEqns[phasei]
+          + HUEqns[phasei]
+          + fvm::Sp(dragDiag[phasei], UAlpha)
+          + fvm::Sp(vmDiag[phasei], UAlpha)
+            ==
+            dragSource[phasei]
+          + alpha*(phase.rho() - rho)*g
+          + (
+                ddtUEqns[phasei].A()
+              + HUEqns[phasei].A()
+              + dragDiag[phasei]
+            )
+           *fvc::reconstruct
+            (
+                phigs[phasei]
+              - alpharAUfs[phasei]*fvc::snGrad(p_rgh)*mesh.magSf()
+            )
+          + vmSource[phasei]
+          + forcesSource[phasei]
+        );
+
+        UEqns.relax();
+        UEqns.solve();
+    }
+}
+
+// rAUfs, alpharAUfs, phigs WITH field relaxation of UAlpha
+forAll(phases, phasei)
+{
+    phaseModel& phase = phases[phasei];
+
+    rAUfs.set
+    (
+        phasei,
+        1.0
+       /(
+            1.0/max(relaxU[phasei], small)
+          + rHUfs[phasei]*fvc::interpolate(ddtUEqns[phasei].A())
+          + rHUfs[phasei]*dragDiagf[phasei]
+          + rHUfs[phasei]*vmDiagf[phasei]
+        )
+    );
+
+    rHAUfs.set(phasei, rHUfs[phasei]*rAUfs[phasei]);
+
+    // Phase diagonal coefficients
+    alpharAUfs.set
+    (
+        phasei,
+        rHUfs[phasei]*rAUfs[phasei]
+       *(alphafs[phasei] + dragPCoefff[phasei])
+    );
+
+    // Combined buoyancy and force fluxes
+    phigs.set
+    (
+        phasei,
+        alpharAUfs[phasei]
+       *(
+          - ghSnGradRho
+          + fluid.surfaceTension(phase)*mesh.magSf()
+        )
+    );
+}
+
+// Construct pressure "diffusivity"
+surfaceScalarField rAUf
+(
+    IOobject
+    (
+        "rAUf",
+        runTime.timeName(),
+        mesh
+    ),
+    mesh,
+    dimensionedScalar(dimensionSet(-1, 3, 1, 0, 0), Zero)
+);
+
+forAll(phases, phasei)
+{
+    rAUf += alphafs[phasei]*alpharAUfs[phasei];
+}
+
+rAUf = mag(rAUf);
